#include <gtk/gtk.h>
#include <stdio.h>

#include "dirFunc.h"
#include "strfunc.h"
#include "filefunc.h"
#include "imgfind.h"
#include "mainWindow.h"
#include "mv_cp.h"


GtkWidget *okno;
GtkWidget *dir_clist;

row_currently_selected = 0;
gint dir_deep = 0;
gint dir_option;
dir_option = 0;
/* dir option 
0 - disable
1 - new;
2 - selected

*/





void
manDirTab_make_clist		(void)
{
	gchar *record[] = {"typ", "category", "exec", "icon", "icon", "name", "comment", "startup", "adress","file lines", "genericname","type"};
	
	dir_clist = gtk_clist_new_with_titles(12, record); 

	
	
	gtk_container_add(GTK_CONTAINER(lookup_widget(okno, "scrolledwindow_dir_view")), dir_clist);
	
//	gtk_clist_set_sort_column(dir_clist, 1);
//	gtk_clist_set_sort_type(dir_clist, GTK_SORT_ASCENDING);
//	gtk_clist_sort(dir_clist);
	
	gtk_widget_show( dir_clist );
	
	gtk_clist_set_column_auto_resize(dir_clist, 0, TRUE);	// typ
//gtk_clist_set_column_visibility(dir_clist, 0, FALSE);
	gtk_clist_set_column_auto_resize(dir_clist, 1, TRUE);	// category
gtk_clist_set_column_visibility(dir_clist, 1, FALSE);
	gtk_clist_set_column_auto_resize(dir_clist, 2, TRUE);	// exec
gtk_clist_set_column_visibility(dir_clist, 2, FALSE);
	gtk_clist_set_column_auto_resize(dir_clist, 3, TRUE);	// icon
gtk_clist_set_column_visibility(dir_clist, 3, FALSE);
	//gtk_clist_set_column_auto_resize(dir_clist, 4, TRUE);	// not use
//gtk_clist_set_column_visibility(dir_clist, 4, FALSE);
gtk_clist_set_column_width(dir_clist, 4, 32);
gtk_clist_set_row_height(dir_clist, 32);
	gtk_clist_set_column_auto_resize(dir_clist, 5, TRUE);	// name
	//gtk_clist_set_column_visibility(dir_clist, 5, FALSE);
	gtk_clist_set_column_auto_resize(dir_clist, 6, TRUE);	// comment
	gtk_clist_set_column_visibility(dir_clist, 6, FALSE);
	gtk_clist_set_column_auto_resize(dir_clist, 7, TRUE);	// startup
gtk_clist_set_column_visibility(dir_clist, 7, FALSE);	
	gtk_clist_set_column_auto_resize(dir_clist, 8, TRUE);	// adres to file
//gtk_clist_set_column_visibility(dir_clist, 8, FALSE);
	gtk_clist_set_column_auto_resize(dir_clist, 9, TRUE);	// file lines 
gtk_clist_set_column_visibility(dir_clist, 9, FALSE);
	gtk_clist_set_column_auto_resize(dir_clist, 10, TRUE);	// generic name
gtk_clist_set_column_visibility(dir_clist, 10, FALSE);
	gtk_clist_set_column_auto_resize(dir_clist, 11, TRUE);	// type
gtk_clist_set_column_visibility(dir_clist, 11, FALSE);
	
	
	g_signal_connect ((gpointer) dir_clist, "select_row",
                    G_CALLBACK (manDirTab_clist_selected),
                    NULL);	
	
}


void
manDirTab_clist_selected	(GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	gchar *cell_tmp;
	gchar *icon_icon;
	GtkWidget *icon;
	gchar *char_tmp;
	
	row_selected_clipboard = row;
	row_currently_selected = row;
	
	manDirTab_clear();
	
	gtk_clist_get_text( dir_clist, row, 0, &cell_tmp);
	
//	text_debug_add(g_strdup_printf("- dir row selected:%i\n",row));
	
	if( strcmp(cell_tmp, "dir") == 0 )
	{
		gtk_widget_set_sensitive(
			lookup_widget( okno, "button_cut"),
			TRUE		
		);
		gtk_widget_set_sensitive(
			lookup_widget( okno, "button_copy"),
			TRUE		
		);
		
		mainWindow_clear();
//		text_debug_add("directory wos selected\n");
		dir_option = 2;
		manDirTab_frame_dir_option();
		manDirTab_set_objects(row);	
		
		//gtk_widget_show( lookup_widget( okno, "button_dir_down_dir") );
		gtk_widget_set_sensitive( 
			lookup_widget( okno, "button_dir_down_dir") ,
			TRUE		
		);
			
	} else {
		gtk_widget_set_sensitive(
			lookup_widget( okno, "button_cut"),
			TRUE		
		);
		gtk_widget_set_sensitive(
			lookup_widget( okno, "button_copy"),
			TRUE		
		);
		
		mainWindow_clear();
		//gtk_widget_hide( lookup_widget( okno, "button_dir_down_dir") );
		gtk_widget_set_sensitive( 
			lookup_widget( okno, "button_dir_down_dir") ,
			FALSE		
		);
		//----------------------------
		filefunc_which_selected(row);
	
		gtk_clist_get_text(dir_clist, row, 11,&cell_tmp);
		gtk_entry_set_text(
			lookup_widget( GTK_WIDGET(okno), "entry_type"),
			cell_tmp);
		
		gtk_clist_get_text(dir_clist, row, 10,&cell_tmp);
		gtk_entry_set_text(
			lookup_widget( GTK_WIDGET(okno), "entry_generic"),
			cell_tmp);	
		
		gtk_clist_get_text(dir_clist, row, 8,&cell_tmp);
		gtk_label_set_text(
			lookup_widget( GTK_WIDGET(okno), "label_addres"),
			cell_tmp);	
			
		gtk_clist_get_text(dir_clist, row, 5,&cell_tmp);
		gtk_entry_set_text(
			lookup_widget( GTK_WIDGET(okno), "entry_name"),
			cell_tmp);
		
		gtk_clist_get_text(dir_clist, row, 6,&cell_tmp);
		gtk_entry_set_text(
			lookup_widget( GTK_WIDGET(okno), "entry_comment"),
			cell_tmp);
		
		gtk_clist_get_text(dir_clist, row, 2,&cell_tmp);
		gtk_entry_set_text(
			lookup_widget( GTK_WIDGET(okno), "entry_command"),
			cell_tmp);
		
		gtk_clist_get_text(dir_clist, row, 1,&cell_tmp);
		gtk_combo_box_set_active(
			lookup_widget( GTK_WIDGET(okno), "comboboxentry_folder"),
			whitch_folder_int(cell_tmp) );
		
		gtk_button_set_label(
			lookup_widget( GTK_WIDGET(okno), "button2"),
			"");	
		
		
		gtk_clist_get_text(dir_clist, row, 3,&cell_tmp);	
		icon_icon = g_strdup(cell_tmp);
		icon = gtk_image_new();
		gtk_image_set_from_file( icon, imagefinder_path( icon_icon ) );
		gtk_widget_show(icon);
		gtk_button_set_image( lookup_widget(okno, "button2"), 
			icon);	
		
		gtk_clist_get_text(dir_clist, row, 7,&cell_tmp);
		if(	strcmp(cell_tmp, "true") == 0)
			gtk_toggle_button_set_active(
				lookup_widget( GTK_WIDGET(okno), "checkbutton_startuo_notify"),
				TRUE);
		else
			gtk_toggle_button_set_active(
				lookup_widget( GTK_WIDGET(okno), "checkbutton_startuo_notify"),
				FALSE);
		
		//----------------------------	
		
	}

}

int
manDirTab_set_objects				(gint row)
{
	GtkWidget *icon;
	FILE *fp;
	gchar *address_dir;
	gchar *linia;
	gchar *img_true_address;
	linia = malloc(1024);
	gchar *tmp;
	
	gtk_clist_get_text( dir_clist, row, 8, &address_dir );
	
	fp = fopen( g_strdup_printf("%s/.directory", address_dir), "r" );
	if( fp )
	{
		while( !feof(fp) ){
			fgets( linia, 1000, fp);
			linia[(strlen(linia)-1)]=0;
		
			tmp = g_strdup(linia);
			tmp[5] = 0;
			if( strcmp(tmp, "Icon=") == 0 )
			{
				linia = linia+5;
				// icon part
				gtk_button_set_label( lookup_widget(okno, "button_dir_icon"), 
					"");
				img_true_address = g_strdup(imagefinder_path(linia));
				icon = gtk_image_new();
				gtk_image_set_from_file( icon, img_true_address );
				gtk_widget_show(icon);
				gtk_button_set_image( lookup_widget(okno, "button_dir_icon"), 
					icon);				
				//icon part 
				gtk_label_set_text( lookup_widget(okno, "label_dir_icon_address"), img_true_address );
			} else if( strcmp(tmp, "Name=") == 0 )
			{
				linia = linia+5;
				gtk_entry_set_text( lookup_widget(okno, "entry_dir_name"), g_strdup(linia) );				
			}						
			
		}
		
		fclose(fp);
	} else {
		gtk_clist_get_text( dir_clist, row, 5, &linia);
		gtk_entry_set_text( lookup_widget(okno, "entry_dir_name"), g_strdup(linia) );		
	}
	
	
}


void
manDirTab_frame_dir_option(void)
{

	if( dir_option == 0 )
	{
		gtk_widget_show( lookup_widget(okno, "button_dir_ok") );
		gtk_widget_show( lookup_widget(okno, "button_dir_del") );
		gtk_widget_show( lookup_widget(okno, "button_dir_new") );
		gtk_widget_set_sensitive(
			lookup_widget( okno, "frame_dir_option"),
			FALSE		
			);
	
	} else if( dir_option == 1)
	{
		gtk_widget_hide( lookup_widget(okno, "button_dir_ok") );
		gtk_widget_hide( lookup_widget(okno, "button_dir_del") );
		gtk_widget_show( lookup_widget(okno, "button_dir_new") );
		gtk_widget_set_sensitive(
			lookup_widget( okno, "frame_dir_option"),
			TRUE		
			);
		
	} else if( dir_option == 2)
	{
		gtk_widget_show( lookup_widget(okno, "button_dir_ok") );
		gtk_widget_show( lookup_widget(okno, "button_dir_del") );
		gtk_widget_hide( lookup_widget(okno, "button_dir_new") );
		gtk_widget_set_sensitive(
			lookup_widget( okno, "frame_dir_option"),
			TRUE		
			);
		
	}
		
}


void
manDirTab_button_execute	(gboolean button)
{
	gchar *cell_tmp;
	
	manDirTab_clear();
	
	if( button == TRUE )
	{
		dir_deep = 0;
		//gtk_widget_hide( lookup_widget( okno, "button_dir_up_dir") );
		gtk_widget_set_sensitive( 
			lookup_widget( okno, "button_dir_up_dir") ,
			FALSE		
		);
		//gtk_widget_hide( lookup_widget( okno, "button_dir_down_dir") );
		gtk_widget_set_sensitive( 
			lookup_widget( okno, "button_dir_down_dir") ,
			FALSE		
		);
	
		dir_work_address = g_strdup_printf("%s", gtk_combo_box_get_active_text(
				lookup_widget( okno, "combobox_dir_selector")
				)
		);
	}
	
	
	if( dir_deep == 0 )
		dir_work_address = g_strdup_printf("%s", gtk_combo_box_get_active_text(
				lookup_widget( okno, "combobox_dir_selector")
				)
		);
	
	if( strcmp(dir_work_address,  g_strdup_printf("%s", gtk_combo_box_get_active_text(
				lookup_widget( okno, "combobox_dir_selector")
				)
		) ) != 0 )
	{
		//gtk_widget_show( lookup_widget( okno, "button_dir_up_dir") );
		gtk_widget_set_sensitive( 
			lookup_widget( okno, "button_dir_up_dir") ,
			TRUE		
		);
	} else {
		//gtk_widget_hide( lookup_widget( okno, "button_dir_up_dir") );
		gtk_widget_set_sensitive( 
			lookup_widget( okno, "button_dir_up_dir") ,
			FALSE		
		);
	}
	
	
	
//	text_debug_add(dir_work_address);
//	text_debug_add("\nexecute button clicked\n");
	
//	text_debug_add("clear clist\n");
	gtk_clist_clear(dir_clist);
	
//	text_debug_add("make list dir i work address\n");
	manDirTab_make_list_dir();
	
//	text_debug_add("make list on clist\n");
	manDirTab_make_clist_dir();
	
	
//	text_debug_add("set up a dir option\n");
	dir_option = 1;
	manDirTab_frame_dir_option();
//	text_debug_add("set up a dir option finished\n");
	
	gtk_label_set_text( lookup_widget( okno, "label_dest_file"),
		g_strdup(dir_work_address)
	);
	
	
}

int
manDirTab_make_clist_dir	(void)
{
	FILE *fp;
	gchar *linia;
	gint count = 0;
	gint linia_nr = 0;
	
	linia = malloc(1024);
	// dirs	
	fp = fopen( g_strdup_printf("%s/%s", g_get_home_dir(), "gmenu_editor_dir_list.tmp"), "r");
	if (fp){
		while( !feof(fp) ){
			fgets( linia, 1023, fp);
			linia_nr++;
			if( linia_nr >=3 )
			{
				linia[(strlen(linia)-1)]=0;
				
				gchar *record[] = {"dir", "category", "exec", "icon", "", linia, "comment", "startup", g_strdup_printf("%s/%s", dir_work_address,linia),"file lines", "genericname","type"};
				gint nr = gtk_clist_append(GTK_CLIST(dir_clist), record);
				manDirTab_make_dir_icon(nr, g_strdup_printf("%s/%s/.directory", dir_work_address,linia) );
								
				count++;
			}
		}
		
		fclose(fp);
	}
					
	gtk_clist_remove(dir_clist, (count-1));
	count--;
	
	if( count == 0 )
		//gtk_widget_hide( lookup_widget(okno, "button_dir_down_dir"));
		gtk_widget_set_sensitive( 
				lookup_widget( okno, "button_dir_down_dir") ,
				FALSE		
			);
	
	// files
	fp = fopen( g_strdup_printf("%s/%s", g_get_home_dir(), "gmenu_editor_links_list.tmp"), "r");
	if (fp){
		while( !feof(fp) ){
			fgets( linia, 1023, fp);
				linia[(strlen(linia)-1)]=0;
				
				//gchar *record[] = {"link", "category", "exec", "icon", "", linia, "comment", "startup", g_strdup_printf("%s/%s", dir_work_address,linia),"file lines", "genericname","type"};
				//gtk_clist_append(GTK_CLIST(dir_clist), record);
				printf("start analaiz a dir structure\n");
				make_rec_from_file(g_strdup_printf("%s/%s", dir_work_address,linia), TRUE, 1);
				
				
				count++;
		}
		
		fclose(fp);
	}
					
	//gtk_clist_remove(dir_clist, (count-1));
	
	return 0;
}



int
manDirTab_make_list_dir		(void)
{
	gchar *address;
	
	address = g_strdup(dir_work_address);
//	text_debug_add(g_strdup_printf("--address--%s---\n", dir_work_address));
	
	remove( g_strdup_printf("%s/%s", g_get_home_dir(), "gmenu_editor_dir_list.tmp") );
	system(g_strdup_printf("for i in `ls -a %s`; do if [ -d \"%s/$i\" ];then echo \"$i\" >> %s/%s; fi;  done", address, address, g_get_home_dir(), "gmenu_editor_dir_list.tmp" ));
	
	remove( g_strdup_printf("%s/%s", g_get_home_dir(), "gmenu_editor_links_list.tmp") );
	system(g_strdup_printf("for i in `ls %s | grep desktop`; do if [ -f \"%s/$i\" ];then echo \"$i\" >> %s/%s; fi;  done", address, address, g_get_home_dir(), "gmenu_editor_links_list.tmp" ));
	
	return 0;
}




void
manDirTab_tab_change	(void)
{
	gint page_no;
	gchar *type_tmp;
	
	 gtk_widget_set_sensitive(
		lookup_widget( okno, "button_cut"),
		FALSE
	);
	gtk_widget_set_sensitive(
		lookup_widget( okno, "button_copy"),
		FALSE		
	);
	
	
	page_no = gtk_notebook_get_current_page(
		lookup_widget( okno, "notebook3")
		);
	
	if( page_no == 0 )
	{
			
		/*	
		gtk_widget_hide(
			lookup_widget( okno, "label6")
			);
		gtk_widget_hide(
			lookup_widget( okno, "comboboxentry_folder")
			);
		*/	
		gtk_widget_set_sensitive(
			lookup_widget( okno, "label6"),
			FALSE		
			);
		gtk_widget_set_sensitive(
			lookup_widget( okno, "comboboxentry_folder"),
			FALSE		
			);
		gtk_widget_set_sensitive(
			lookup_widget( okno, "frame_dir_option"),
			TRUE		
			);
		
		dir_deep = 0;
		
		manDirTab_button_execute(TRUE);
		
		mainWindow_clear();
	
	} else {
		/*
		gtk_widget_show(
			lookup_widget( okno, "label6")
			);
		gtk_widget_show(
			lookup_widget( okno, "comboboxentry_folder")
			);
		
		*/
		gtk_widget_set_sensitive(
			lookup_widget( okno, "label6"),
			TRUE		
			);
		gtk_widget_set_sensitive(
			lookup_widget( okno, "comboboxentry_folder"),
			TRUE		
			);
		gtk_widget_set_sensitive(
			lookup_widget( okno, "frame_dir_option"),
			FALSE		
			);
	
		mainWindow_clear();	
	}
	
}



int
manDirTab_make_new_directory	(void)
{
	gchar *file_name;
	gchar *name;
	gchar *icon_address;
	FILE *fp;
	
//	text_debug_add("make new directory start\n");
	
	icon_address = g_strdup(
		gtk_label_get_text( lookup_widget( okno, "label_dir_icon_address") ) 
	);
	name = g_strdup(
		gtk_entry_get_text( lookup_widget( okno, "entry_dir_name") )
	);
	
	file_name = g_strdup( space_replace(name) );
	
	name = g_strdup(
		gtk_entry_get_text( lookup_widget( okno, "entry_dir_name") )
	);
	
	//text_debug_add( g_strdup_printf("----- colected data\ndir name: %s\nicon address: %s\nname: %s\n----- colected data\n", file_name, icon_address, name) );
	
//	text_debug_add("make new dir\n");
//	text_debug_add(g_strdup_printf("mkdir %s/%s", dir_work_address, file_name));
	system( g_strdup_printf("mkdir %s/%s\n", dir_work_address, file_name) );
	
//	text_debug_add("make dir file extensions \".directory\"\n");	
//	text_debug_add(g_strdup_printf("%s/%s/.directory\n", dir_work_address, file_name) );
	fp = fopen( g_strdup_printf("%s/%s/.directory", dir_work_address, file_name), "w+");
	if( fp )
	{
		fprintf(fp,
			"[Desktop Entry]\nType=Directory\nX-Created-by=gmenu-editor\nIcon=%s\n\nName=%s\n",
			icon_address,
			name
		);
			
		fclose(fp);
	}
	
	
	manDirTab_clear();
	manDirTab_button_execute(FALSE);
	
//	text_debug_add("make new directory end\n directory wos created :)\n");
	return 0;
}


void
manDirTab_clear						(void)
{
	gtk_entry_set_text(
		lookup_widget(okno, "entry_dir_name"),
		"");
	gtk_label_set_text(
		lookup_widget(okno, "label_dir_icon_address"),
		"not set");
	gtk_button_set_image(
		lookup_widget(okno, "button_dir_icon"),
		NULL);
	gtk_button_set_label(
		lookup_widget(okno, "button_dir_icon"),
		"No Icon");	
	
	dir_option = 1;
	manDirTab_frame_dir_option();	
	
}


int
manDirTab_save_new_data_directory	(void)
{
	gchar *name;
	gchar *icon_address;
	gchar *work_on_file_address;
	FILE *fp;
	
//	text_debug_add("saving new data for directory start\n");
	
	icon_address = g_strdup( 
		gtk_label_get_text( lookup_widget( okno, "label_dir_icon_address") )
	);
	name = g_strdup( 
		gtk_entry_get_text( lookup_widget( okno, "entry_dir_name") )
	);
	gtk_clist_get_text(dir_clist, row_currently_selected, 8, &work_on_file_address);
	
	
	fp = fopen( g_strdup_printf("%s/.directory", work_on_file_address), "w+");
	if( fp )
	{
		fprintf(fp,
			"[Desktop Entry]\nType=Directory\nX-Created-by=gmenu-editor\nIcon=%s\n\nName=%s\n",
			icon_address,
			name
		);
			
		fclose(fp);
	}
	
	manDirTab_clear();
	manDirTab_button_execute(FALSE);
	
//	text_debug_add("saving new data for directory finished\n");
	return 0;
}


int
manDirTab_go_into_a_directory			(void)
{
	 gtk_widget_set_sensitive(
		lookup_widget( okno, "button_cut"),
		FALSE		
	);
	gtk_widget_set_sensitive(
		lookup_widget( okno, "button_copy"),
		FALSE		
	);
	
	
	//gtk_widget_hide(lookup_widget(okno, "button_dir_down_dir"));	
	gtk_widget_set_sensitive( 
			lookup_widget( okno, "button_dir_down_dir") ,
			FALSE		
		);
	dir_deep++;
	printf(g_strdup_printf("change directory\ncurent directory: %s\n" , dir_work_address));
	gtk_clist_get_text(dir_clist, row_currently_selected, 8, &dir_work_address);
	dir_work_address = g_strdup_printf("%s", dir_work_address);
	printf(g_strdup_printf("new dir is: %s---\n", dir_work_address));
	manDirTab_button_execute(FALSE);
	printf(g_strdup_printf("--go to--%s---\n", dir_work_address));
	
	
	return 0;
}

int
manDirTab_go_up_a_directory				(void)
{
	 gtk_widget_set_sensitive(
		lookup_widget( okno, "button_cut"),
		FALSE		
	);
	gtk_widget_set_sensitive(
		lookup_widget( okno, "button_copy"),
		FALSE		
	);
	
	dir_deep--;
	printf(g_strdup_printf("change directory\ncurent directory: %s\n" , dir_work_address));
	dir_work_address = g_strdup_printf("%s/..", dir_work_address);
	printf(g_strdup_printf("new dir is: %s---\n", dir_work_address));
	manDirTab_button_execute(FALSE);
	printf(g_strdup_printf("--go to--%s---\n", dir_work_address));
	//gtk_widget_hide(lookup_widget(okno, "button_dir_down_dir"));
	gtk_widget_set_sensitive( 
			lookup_widget( okno, "button_dir_down_dir") ,
			FALSE		
		);
	
	
	return 0;
	
	
}


int
manDirTab_delete_direcotry					(void)
{
	gchar *system_command;
	
//	text_debug_add("delet a directory from menu\n");
	gtk_clist_get_text(dir_clist, row_currently_selected, 8, &system_command);
	system_command = g_strdup_printf("rm -r %s", system_command);
	system(system_command);
	manDirTab_button_execute(FALSE);
	
//	text_debug_add("delet a directory complet\n");
	
	return 0;
}


void
manDirTab_make_dir_icon					(gint nr, gchar *path)
{
	GdkPixbuf *pixbuf_from_file;
	GdkPixbuf *pixbuf_from_pixbuf;
	GdkPixmap *icon_pixmap_from_pixbuf;
	GdkBitmap *icon_mask_form_pixbuf;
	FILE *fp;
	gchar *linia;
	linia = malloc(1024);
	gchar *tmp;
	gchar *icon_address_tmp;
	
	icon_address_tmp = g_strdup("not set");
	
	fp = fopen( path, "r" );
	if( fp )
	{
		while( !feof(fp) ){
			fgets( linia, 1000, fp);
			linia[(strlen(linia)-1)]=0;
			
			if( strlen(linia) >=5 )
			{
				tmp = g_strdup(linia);
				tmp[5] = 0;
				if( strcmp(tmp, "Icon=") == 0 )
				{
					linia = linia+5;
					// icon part
					icon_address_tmp = g_strdup(imagefinder_path(linia));
				}
			}
		}
		fclose(fp);
	}

	
	if( image_true_false(imagefinder_path(icon_address_tmp)) == TRUE ){
		pixbuf_from_file = gdk_pixbuf_new_from_file(imagefinder_path(icon_address_tmp), NULL);
		pixbuf_from_pixbuf = gdk_pixbuf_scale_simple(pixbuf_from_file, 32, 32, TRUE);
		gdk_pixbuf_render_pixmap_and_mask(pixbuf_from_pixbuf, &icon_pixmap_from_pixbuf, &icon_mask_form_pixbuf, 50);
		gtk_clist_set_pixmap(GTK_CLIST(dir_clist),nr ,4, icon_pixmap_from_pixbuf, icon_mask_form_pixbuf);
	} else {
		pixbuf_from_file = gdk_pixbuf_new_from_xpm_data(manDirTab_dir_icon);
		gdk_pixbuf_render_pixmap_and_mask(pixbuf_from_file, &icon_pixmap_from_pixbuf, &icon_mask_form_pixbuf, 50);
		gtk_clist_set_pixmap(GTK_CLIST(dir_clist),nr ,4, icon_pixmap_from_pixbuf, icon_mask_form_pixbuf);
	}
	
	
}
