#include <gtk/gtk.h>


gchar *dir_work_address;
gint row_currently_selected;


void
manDirTab_tab_change	(void);

void
manDirTab_make_clist		(void);

void
manDirTab_clist_selected	(GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);
										
void
manDirTab_button_execute	(gboolean button);

int
manDirTab_make_list_dir		(void);

int
manDirTab_make_clist_dir	(void);

void
manDirTab_frame_dir_option(void);

int
manDirTab_make_new_directory	(void);

void
manDirTab_clear						(void);

int
manDirTab_set_objects				(gint row);

int
manDirTab_save_new_data_directory	(void);

int
manDirTab_go_into_a_directory			(void);

int
manDirTab_go_up_a_directory				(void);

int
manDirTab_delete_direcotry					(void);

void
manDirTab_make_dir_icon					(gint nr, gchar *path);

static char * manDirTab_dir_icon[] = {
"32 32 206 2",
"  	c None",
". 	c #FFFFFF",
"+ 	c #FCFCFC",
"@ 	c #EBEBEC",
"# 	c #E4E5E6",
"$ 	c #FEFEFE",
"% 	c #F4F4F4",
"& 	c #D4D5D7",
"* 	c #ABACB1",
"= 	c #94969C",
"- 	c #9B9DA1",
"; 	c #F8F9F9",
"> 	c #F9F9F9",
", 	c #E3E3E5",
"' 	c #B9BABE",
") 	c #9A9CA1",
"! 	c #A2A3A8",
"~ 	c #BEBEC0",
"{ 	c #CECFCF",
"] 	c #999BA0",
"^ 	c #E6E7E8",
"/ 	c #FDFDFD",
"( 	c #EDEEEF",
"_ 	c #C8C9CC",
": 	c #A1A3A8",
"< 	c #9A9BA0",
"[ 	c #B3B4B7",
"} 	c #CCCCCD",
"| 	c #D6D6D6",
"1 	c #D7D7D7",
"2 	c #ACAEB1",
"3 	c #C5C6C9",
"4 	c #E4E4E6",
"5 	c #ABADB1",
"6 	c #8B8D93",
"7 	c #F5F6F6",
"8 	c #D8D9DB",
"9 	c #AEB0B3",
"0 	c #999B9F",
"a 	c #A9ABAE",
"b 	c #C5C5C7",
"c 	c #D3D3D4",
"d 	c #BABBBD",
"e 	c #888A90",
"f 	c #81848A",
"g 	c #64676F",
"h 	c #6B6E76",
"i 	c #898B92",
"j 	c #FAFAFB",
"k 	c #E6E6E7",
"l 	c #BDBEC2",
"m 	c #9C9EA3",
"n 	c #9FA1A5",
"o 	c #BBBCBE",
"p 	c #CFCFCF",
"q 	c #D4D4D4",
"r 	c #B1B2B5",
"s 	c #86888E",
"t 	c #666970",
"u 	c #696C74",
"v 	c #98999E",
"w 	c #CCCCCE",
"x 	c #97999F",
"y 	c #F0F0F1",
"z 	c #CDCED1",
"A 	c #A5A6AB",
"B 	c #B0B1B4",
"C 	c #CBCBCC",
"D 	c #C8C8C9",
"E 	c #9EA0A4",
"F 	c #72757C",
"G 	c #BCBDBF",
"H 	c #929499",
"I 	c #6B6E75",
"J 	c #696C73",
"K 	c #898A8F",
"L 	c #AAAAAC",
"M 	c #A0A1A3",
"N 	c #BBBBBD",
"O 	c #D9D9D9",
"P 	c #8C8E94",
"Q 	c #A5A7AB",
"R 	c #F7F7F8",
"S 	c #DCDDDE",
"T 	c #B2B3B7",
"U 	c #C3C3C5",
"V 	c #D1D1D1",
"W 	c #85878D",
"X 	c #656870",
"Y 	c #C6C6C7",
"Z 	c #9E9FA3",
"` 	c #74777E",
" .	c #7F8187",
"..	c #A0A1A4",
"+.	c #BDBEBE",
"@.	c #C0C0C0",
"#.	c #AFB0B1",
"$.	c #A5A6A9",
"%.	c #D8D8D8",
"&.	c #83868B",
"*.	c #B3B5B8",
"=.	c #FBFCFC",
"-.	c #E9E9EA",
";.	c #C1C2C5",
">.	c #9D9FA3",
",.	c #B7B8BA",
"'.	c #A6A8AB",
").	c #6F7179",
"!.	c #686A72",
"~.	c #88898E",
"{.	c #ACADAF",
"].	c #A5A6A8",
"^.	c #98999D",
"/.	c #B8B8B9",
"(.	c #BBBBBB",
"_.	c #999A9D",
":.	c #D1D2D2",
"<.	c #797C83",
"[.	c #DFE0E1",
"}.	c #A6A8AD",
"|.	c #ADAEB2",
"1.	c #C8C8CA",
"2.	c #D5D5D5",
"3.	c #797B82",
"4.	c #8A8C91",
"5.	c #BBBCBC",
"6.	c #A3A4A7",
"7.	c #8E8F94",
"8.	c #AFB0B2",
"9.	c #BFBFBF",
"0.	c #9D9EA1",
"a.	c #C1C2C2",
"b.	c #CFD0D2",
"c.	c #CECFD1",
"d.	c #96979C",
"e.	c #D0D0D1",
"f.	c #D6D6D7",
"g.	c #BABABC",
"h.	c #A6A7AA",
"i.	c #ABACAD",
"j.	c #AAABAE",
"k.	c #DDDEDF",
"l.	c #F5F5F5",
"m.	c #9D9FA4",
"n.	c #8D8F94",
"o.	c #666971",
"p.	c #818288",
"q.	c #B6B6B7",
"r.	c #B9B9BA",
"s.	c #94969A",
"t.	c #CDCED0",
"u.	c #A2A3A7",
"v.	c #808389",
"w.	c #939498",
"x.	c #8E9094",
"y.	c #787B81",
"z.	c #9A9B9E",
"A.	c #919397",
"B.	c #70737A",
"C.	c #A2A3A5",
"D.	c #A6A7A9",
"E.	c #83858B",
"F.	c #86898F",
"G.	c #686B73",
"H.	c #A8A9AC",
"I.	c #95979B",
"J.	c #6F7279",
"K.	c #9B9DA2",
"L.	c #DADBDD",
"M.	c #ACACAE",
"N.	c #C1C1C1",
"O.	c #A8A9AB",
"P.	c #84868C",
"Q.	c #7B7D84",
"R.	c #CBCCCC",
"S.	c #B4B4B6",
"T.	c #676A72",
"U.	c #989A9F",
"V.	c #D7D8DA",
"W.	c #C1C2C3",
"X.	c #BBBCBD",
"Y.	c #AAABAD",
"Z.	c #87898E",
"`.	c #787A81",
" +	c #B5B7BA",
".+	c #F1F1F2",
"++	c #AEAFB2",
"@+	c #BABABB",
"#+	c #999B9E",
"$+	c #74767D",
"%+	c #94969B",
"&+	c #D3D4D6",
"*+	c #ADADAF",
"=+	c #898A90",
"-+	c #75777E",
";+	c #EFEFF0",
">+	c #878990",
",+	c #767980",
"'+	c #909298",
")+	c #D0D0D3",
"!+	c #71747B",
"~+	c #AEAFB4",
"{+	c #ECEDEE",
"]+	c #F3F3F4",
"^+	c #D2D2D5",
"/+	c #FAFAFA",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . + @ # $ . . . . . ",
". . . . . . . . . . . . . . . . . . . . $ % & * = - ; . . . . . ",
". . . . . . . . . . . . . . . . . . > , ' ) ! ~ { ] ^ . . . $ . ",
". . . . . . . . . . . . . . . / ( _ : < [ } | 1 1 2 3 . 4 5 6 . ",
". . . . . . . . . . . . $ 7 8 9 0 a b c 1 1 1 1 1 d e f g h i . ",
". . . . . . . . . . j k l m n o p q 1 1 1 1 c r s t u v w ) x . ",
". . . . . . . / y z A ] B C D E F } 1 | G H I J K L M N O P Q . ",
". . . . $ R S T 0 Q U V [ W X I g Y Z ` g  ...+.@.@.#.$.%.&.*.. ",
". . =.-.;.E >.,.{ | '.).!.~.{.].g g ` ^./.@.@.@.@.@.(._.:.<.;.. ",
". [.}.] |.1.2.1 1 1 3.4.5.@.@.6.7.8.@.@.@.@.@.@.@.@.9.0.a.h b.. ",
". c.d.e.f.1 1 1 | g.J h.@.@.@.@.@.@.@.@.@.@.@.@.@.@.@.i.j.g k.. ",
". l.m.Y 1 1 1 1 n.o.p.q.@.@.@.@.@.@.@.@.@.@.@.@.@.@.@.r.s.g @ . ",
". . t.u.2.1 1 1 v.w.@.@.@.@.@.@.@.@.@.@.@.@.@.@.@.@.@.9.x.g > . ",
". . l.m.Y 1 1 1 y.z.@.@.@.@.@.@.@.@.@.@.@.@.@.@.@.@.@.@.A.J . . ",
". . . t.u.2.1 1 B.C.@.@.@.@.@.@.@.@.@.@.@.@.@.@.@.@.D.E.g F.. . ",
". . . l.m.Y 1 1 G.H.@.@.@.@.@.@.@.@.@.@.@.@.@./.I.J.G.K.L.. . . ",
". . . . t.u.2.c g M.@.@.@.@.@.@.@.@.@.@.N.O.P.X Q.' % . . . . . ",
". . . . l.m.Y R.g S.@.@.@.@.@.@.@.@.r.^.F T.U.V.$ . . . . . . . ",
". . . . . t.u.W.g X.@.@.@.@.@.@.Y.Z.o.`. +.+. . . . . . . . . . ",
". . . . . l.m.++g N.@.@.@.@+#+$+o.%+&+$ . . . . . . . . . . . . ",
". . . . . . t.6 J 9.@.*+=+T.-+T ;+. . . . . . . . . . . . . . . ",
". . . . . . l.>+B.#+,+X '+)+/ . . . . . . . . . . . . . . . . . ",
". . . . . . . l I !+~+{+. . . . . . . . . . . . . . . . . . . . ",
". . . . . . . ]+^+/+. . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . ",
". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . "};
