#include <gtk/gtk.h>

#include "strfunc.h"
#include "filefunc.h"
#include "imgfind.h"
#include "dirFunc.h"
#include "mainWindow.h"
#include "mv_cp.h"

GtkWidget *okno;
GtkWidget *file_select;
GtkWidget *icon_select;
GtkWidget *dialog1;

GtkWidget *clist_files;

GtkWidget *icon;

gchar *icon_icon;
gchar *icon_file_name;

gint ad_trans_nr = -1;

int
mainWindow_destrou				(void)
{
	gtk_widget_destroy(okno);
	gtk_main_quit();
	exit(1);
	return 0;
}

void
mainWindow_add_to_clist_and_clear(gint row, gint coll, gchar *name)
{	
	
	
	gtk_clist_set_text(
		lookup_widget( okno, "clist3"),
		row,
		coll,
		gtk_entry_get_text(
			lookup_widget( okno, name)
			)
		);
	gtk_entry_set_text(
		lookup_widget( okno, name),
		""
		);
}

void
mainWindow_add_set_func					(void)
{	
	
	gint append;
	gchar *rec_tmp[] = {"","","",""};
	
	if( ad_trans_nr == -1 )
	{	
		append = gtk_clist_append(
			lookup_widget( okno, "clist3"),
			rec_tmp);
		
		mainWindow_add_to_clist_and_clear(append, 0, "entry_ad_lang");
		mainWindow_add_to_clist_and_clear(append, 1, "entry_ad_name");
		mainWindow_add_to_clist_and_clear(append, 2, "entry_ad_gen");
		mainWindow_add_to_clist_and_clear(append, 3, "entry_ad_com");
							
		filefunc_clist3_plus();
		
	} else {
		
		mainWindow_add_to_clist_and_clear(ad_trans_nr, 0, "entry_ad_lang");
		mainWindow_add_to_clist_and_clear(ad_trans_nr, 1, "entry_ad_name");
		mainWindow_add_to_clist_and_clear(ad_trans_nr, 2, "entry_ad_gen");
		mainWindow_add_to_clist_and_clear(ad_trans_nr, 3, "entry_ad_com");
		
	}

	
}


int
mainWindow_clear					(void)
{
	gtk_label_set_text(
		lookup_widget( GTK_WIDGET(okno), "label_addres"),
		"");	
	gtk_entry_set_text(
		lookup_widget( GTK_WIDGET(okno), "entry_name"),
		"");
	gtk_entry_set_text(
		lookup_widget( GTK_WIDGET(okno), "entry_comment"),
		"");
	gtk_entry_set_text(
		lookup_widget( GTK_WIDGET(okno), "entry_generic"),
		"");
	gtk_entry_set_text(
		lookup_widget( GTK_WIDGET(okno), "entry_command"),
		"");
	gtk_entry_set_text(
		lookup_widget( GTK_WIDGET(okno), "entry_type"),
		"Application");
	gtk_combo_box_set_active(
		lookup_widget( GTK_WIDGET(okno), "comboboxentry_folder"),
		0);
	gtk_button_set_image(
		lookup_widget( GTK_WIDGET(okno), "button2"),
		NULL);	
	gtk_button_set_label(
		lookup_widget( GTK_WIDGET(okno), "button2"),
		"No Icon");
	gtk_toggle_button_set_active(
		lookup_widget( GTK_WIDGET(okno), "checkbutton_startuo_notify"),
		FALSE);
		
	ad_trans_nr = -1;
	
	gtk_clist_clear( lookup_widget( okno, "clist3") );
	
	gtk_entry_set_text(
		lookup_widget(okno, "entry_ad_lang"),
		"");
	
	gtk_entry_set_text(
		lookup_widget(okno, "entry_ad_name"),
		"");
	
	gtk_entry_set_text(
		lookup_widget(okno, "entry_ad_gen"),
		"");
	
	gtk_entry_set_text(
		lookup_widget(okno, "entry_ad_com"),
		"");
	
	
	// clean unknown
	GtkTextBuffer *bufferr;
	GtkTextTagTable *to_print;
	 GtkTextIter start;
	GtkTextIter end;	
	to_print = g_strdup("");
	bufferr = gtk_text_view_get_buffer( 
		lookup_widget( okno, "textview1") );
	gtk_text_buffer_get_start_iter(bufferr,&start);
	gtk_text_buffer_get_end_iter(bufferr,&end);
	gtk_text_buffer_delete(bufferr, &start, &end);
	
	gtk_text_buffer_get_end_iter(bufferr,&end);
	gtk_text_buffer_insert(bufferr, &end, to_print, -1);
	//gtk_text_buffer_insert(NULL, &end, to_print, -1);
	
	
	return 0;
}

int
mainWindow_get_other_trans				(gint coll, gchar *name)
{
	gint i;
	gchar *to_return;
	gchar *val_tmp;
	gchar *lang_tmp;
	GtkWidget *clist_tmp;
	
	clist_tmp = lookup_widget( okno, "clist3");
	
	to_return = g_strdup(" ");
	
	i = 0;
	while ( TRUE )
	{
		if( gtk_clist_get_text(clist_tmp, i, 0, &lang_tmp) == 0 || gtk_clist_get_text(clist_tmp, i, coll, &val_tmp) == 0 )
		{			
			break;
		} else {
			if( i == 0 )
				to_return = g_strdup("\n");
			
			gtk_clist_get_text(clist_tmp, i, 0, &lang_tmp);
			gtk_clist_get_text(clist_tmp, i, coll, &val_tmp);
			if( strlen(val_tmp) != 0 )
				to_return = g_strdup_printf("%s%s%s]=%s\n", to_return, name, lang_tmp, val_tmp);
					
			i++;
		}		
	}
	
	to_return[ strlen(to_return)-1 ] = 0;
	return to_return;
}


int
mainWindow_get_unknown					(void)
{
	gchar *to_return;
	GtkTextBuffer* text_buffer=0;
	GtkTextIter start;
	GtkTextIter end;
	
	to_return = g_strdup(" ");
	
	text_buffer = gtk_text_view_get_buffer(
		lookup_widget( okno, "textview1") );
	
	gtk_text_buffer_get_start_iter(text_buffer,&start);
	gtk_text_buffer_get_end_iter(text_buffer,&end);
	to_return = gtk_text_buffer_get_text(text_buffer,&start, &end,TRUE);
	
	
	return to_return;
}

void
mainWindow_new_icon_ok	(void)
{
	GtkWidget *gtkWidgetTmp;
	gchar *icon_name;
	gchar *icon_comment;
	gchar *icon_type;
	gchar *icon_generic;
	gchar *icon_unknown;
	gchar *icon_command;
	gchar *icon_folder;
	gchar *icon_startupNotify;
	gchar *icon_name_func;
	
	gchar *work_in_directory;	
	gint page_no;
	
	FILE *fp;
	
	gtkWidgetTmp = lookup_widget( GTK_WIDGET(okno), "entry_type");
	icon_type = g_strdup( gtk_entry_get_text( gtkWidgetTmp ) );
	
	gtkWidgetTmp = lookup_widget( GTK_WIDGET(okno), "entry_name");
	icon_name = g_strdup( gtk_entry_get_text( gtkWidgetTmp ) );
	icon_name = g_strdup_printf("%s%s", icon_name, mainWindow_get_other_trans(1, "Name[") );
	
	gtkWidgetTmp = lookup_widget( GTK_WIDGET(okno), "entry_comment");
	icon_comment = g_strdup( gtk_entry_get_text( gtkWidgetTmp ) );
	icon_comment = g_strdup_printf("%s%s", icon_comment, mainWindow_get_other_trans(3, "Comment[") );
		
	gtkWidgetTmp = lookup_widget( GTK_WIDGET(okno), "entry_generic");
	icon_generic = g_strdup( gtk_entry_get_text( gtkWidgetTmp ) );
	icon_generic = g_strdup_printf("%s%s", icon_generic, mainWindow_get_other_trans(2, "GenericName[") );
	
	gtkWidgetTmp = lookup_widget( GTK_WIDGET(okno), "entry_command");
	icon_command = g_strdup( gtk_entry_get_text( gtkWidgetTmp ) );
	
		
	if( gtk_toggle_button_get_active( lookup_widget(okno, "checkbutton_startuo_notify") ) == TRUE )
	{
		icon_startupNotify = g_strdup("TRUE");
	} else {
		icon_startupNotify = g_strdup("FALSE");
	}
		
	
	icon_folder = g_strdup_printf("%s", gtk_combo_box_get_active_text( lookup_widget(okno, "comboboxentry_folder") ) ) ;
	
	g_print("file name %s\n",icon_name_func);
	
	//
	page_no = gtk_notebook_get_current_page(
		lookup_widget( okno, "notebook3")
		);
	if( page_no == 0 )  // gnome structure
	{
		if( strcmp(gtk_label_get_text(lookup_widget(okno, "label_addres")), "") == 0 )
		fp = fopen( g_strdup_printf("/usr/share/applications/%s.desktop", 
			g_strdup( space_replace(icon_name) ) ),
			"w" );
		else
			fp = fopen( gtk_label_get_text(lookup_widget(okno, "label_addres")),
			"w" );
		
		icon_unknown = mainWindow_get_unknown();
		
		if( fp )
		{
			fprintf(fp, "[Desktop Entry]\nEncoding=UTF-8\nExec=%s\nType=%s\nCategories=Application;%s;\nIcon=%s\nName=%s\nGenericName=%s\nComment=%s\nStartupNotify=%s\n%s",
				icon_command,
				icon_type,
				icon_folder,
				icon_icon,
				icon_name,
				icon_generic,
				icon_comment,
				icon_startupNotify,
				icon_unknown);
					
			fclose(fp);
		} else {
			g_print("ther was error in wrating file!! \n");
			dialog1 = create_dialog1();
			gtk_label_set_text(
				lookup_widget(dialog1, "label8"),
				"ther was error in wrating file!! start program as root is usually helps");
			gtk_widget_show( dialog1);
			
		}
	} else if( page_no == 1)	// directory structure
	{
		//gchar *dir_work_address;
		//gint row_currently_selected;
		printf("--------------\nadd link to static directory\n");
		work_in_directory = g_strdup(dir_work_address);
		printf(g_strdup_printf("new link in\n%s\n-------------------\n", work_in_directory));
		
				
		
		
		if( strcmp(gtk_label_get_text(lookup_widget(okno, "label_addres")), "") == 0 )
		fp = fopen( g_strdup_printf("%s/%s.desktop", 
			work_in_directory,
			g_strdup( space_replace(icon_name) ) ),
			"w" );
		else
			fp = fopen( gtk_label_get_text(lookup_widget(okno, "label_addres")),
			"w" );
		
		icon_unknown = mainWindow_get_unknown();
		
		if( fp )
		{
			fprintf(fp, "[Desktop Entry]\nEncoding=UTF-8\nExec=%s\nType=%s\n\nIcon=%s\nName=%s\nGenericName=%s\nComment=%s\nStartupNotify=%s\n%s",
				icon_command,
				icon_type,
				icon_icon,
				icon_name,
				icon_generic,
				icon_comment,
				icon_startupNotify,
				icon_unknown);
					
			fclose(fp);
		} else {
			g_print("ther was error in wrating file!! \n");
			dialog1 = create_dialog1();
			gtk_label_set_text(
				lookup_widget(dialog1, "label8"),
				"ther was error in wrating file!! start program as root is usually helps");
			gtk_widget_show( dialog1);
			
		}
		
		
		mainWindow_clear();
		manDirTab_button_execute(FALSE);
		
		
	}



	g_print("-------------------------------------\n[Desktop Entry]\nEncoding=UTF-8\nExec=%s\nType=%s\nCategories=Application;%s;\nIcon=%s\nName=%s\nGenericName=%s\nComment=%s\nStartupNotify=%s\n%s\n-----------------",
		icon_command,
		icon_type,
		icon_folder,
		icon_icon,
		icon_name,
		icon_generic,
		icon_comment,
		icon_startupNotify,
		icon_unknown);

	
}

void
file_chooser_done (GtkFileChooser *chooser,
                            gint            response_id,
                            gpointer        data)
{
	 if (response_id == GTK_RESPONSE_OK)
	{
		gchar   *filename;
		filename = gtk_file_chooser_get_filename (file_select);
		
		gtk_entry_set_text( GTK_ENTRY( lookup_widget(okno, "entry_command") ),
			g_strdup(filename) );
		gtk_widget_hide( file_select );
			
	}	
	 if (response_id == GTK_RESPONSE_CANCEL)
		gtk_widget_hide( file_select );			
		
}


int
mainWindow_file_chooser		(void)
{
	file_select = gtk_file_chooser_dialog_new("select", okno, 
		GTK_FILE_CHOOSER_ACTION_OPEN,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		GTK_STOCK_OPEN,   GTK_RESPONSE_OK,
		NULL);
	
	g_object_add_weak_pointer (G_OBJECT ( file_select ), (gpointer) &file_select);
	g_signal_connect (file_select, "response",
		G_CALLBACK (file_chooser_done),
		NULL);
	
	gtk_widget_show( file_select );
	
	return 0;
}


void
icon_chooser_done (GtkFileChooser *chooser,
                            gint            response_id,
                            gpointer        data)
{
	 if (response_id == GTK_RESPONSE_OK)
	{
		gchar   *filename;
		filename = gtk_file_chooser_get_filename (icon_select);
	
		gtk_button_set_label( lookup_widget(okno, "button2"), "" );
		
		icon_icon = g_strdup(filename);
		
		icon = gtk_image_new();
		gtk_image_set_from_file( icon, icon_icon);
		gtk_widget_show(icon);
		gtk_button_set_image( lookup_widget(okno, "button2"), 
			icon);	
		
		gtk_widget_hide( icon_select );
			
	}	
	 if (response_id == GTK_RESPONSE_CANCEL)
		gtk_widget_hide( icon_select );			
	
}

void
icon_chooser_done_4_dir (GtkFileChooser *chooser,
                            gint            response_id,
                            gpointer        data)
{
	 if (response_id == GTK_RESPONSE_OK)
	{
		gchar   *filename;
		filename = gtk_file_chooser_get_filename (icon_select);
	
		gtk_button_set_label( lookup_widget(okno, "button_dir_icon"), "" );
		
		icon_icon = g_strdup(filename);
		
		icon = gtk_image_new();
		gtk_image_set_from_file( icon, icon_icon);
		gtk_widget_show(icon);
		gtk_button_set_image( lookup_widget(okno, "button_dir_icon"), 
			icon);	
		
		gtk_widget_hide( icon_select );
		
		gtk_label_set_text(	lookup_widget(okno, "label_dir_icon_address"),
			filename);
		
	}	
	 if (response_id == GTK_RESPONSE_CANCEL)
		gtk_widget_hide( icon_select );			
	
}



int
mainWindow_icon_select			(void)
{
	icon_select = gtk_file_chooser_dialog_new("select icon", okno, 
		GTK_FILE_CHOOSER_ACTION_OPEN,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		GTK_STOCK_OPEN,   GTK_RESPONSE_OK,
		NULL);
	g_object_add_weak_pointer (G_OBJECT ( icon_select ), (gpointer) &icon_select);
	g_signal_connect (icon_select, "response",
		G_CALLBACK (icon_chooser_done),
		NULL);
	
	gtk_widget_show( icon_select );
	
	return 0;
}

int
mainWindow_icon_select_4_dir		(void)
{
	icon_select = gtk_file_chooser_dialog_new("select icon 4 directory", okno, 
		GTK_FILE_CHOOSER_ACTION_OPEN,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		GTK_STOCK_OPEN,   GTK_RESPONSE_OK,
		NULL);
	g_object_add_weak_pointer (G_OBJECT ( icon_select ), (gpointer) &icon_select);
	g_signal_connect (icon_select, "response",
		G_CALLBACK (icon_chooser_done_4_dir),
		NULL);
	
	gtk_widget_show( icon_select );
	
	return 0;
}

void
mainWindow_trans_selected				(gint row)
{
	GtkWidget *clist_trans;
	gchar *char_tmp;
	
	clist_trans = lookup_widget(okno, "clist3");
	
	gtk_clist_get_text(clist_trans, row, 0, &char_tmp);
	gtk_entry_set_text(
		lookup_widget(okno, "entry_ad_lang"),
		char_tmp);
	
	gtk_clist_get_text(clist_trans, row, 1, &char_tmp);
	gtk_entry_set_text(
		lookup_widget(okno, "entry_ad_name"),
		char_tmp);
	
	gtk_clist_get_text(clist_trans, row, 2, &char_tmp);
	gtk_entry_set_text(
		lookup_widget(okno, "entry_ad_gen"),
		char_tmp);
	
	gtk_clist_get_text(clist_trans, row, 3, &char_tmp);
	gtk_entry_set_text(
		lookup_widget(okno, "entry_ad_com"),
		char_tmp);
		
	ad_trans_nr = row;
	g_print("ad_trans_row: %i\n", ad_trans_nr);
	
}


int
mainWindow_clist_files_wos_selected         (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	//gchar *record[] = {"typ", "category", "exec", "icon", "ln_icon", "name", "comment", "startup", "adress", "", type};

	gchar *char_tmp;

	row_selected_clipboard = row;
	
	gtk_widget_set_sensitive(
		lookup_widget( okno, "button_cut"),
		TRUE		
	);
	gtk_widget_set_sensitive(
		lookup_widget( okno, "button_copy"),
		TRUE		
	);

	
	
	mainWindow_clear();
	
	filefunc_which_selected(row);
	
	gtk_clist_get_text(clist_files, row, 11,&char_tmp);
	gtk_entry_set_text(
		lookup_widget( GTK_WIDGET(okno), "entry_type"),
		char_tmp);
	
	gtk_clist_get_text(clist_files, row, 10,&char_tmp);
	gtk_entry_set_text(
		lookup_widget( GTK_WIDGET(okno), "entry_generic"),
		char_tmp);	
	
	gtk_clist_get_text(clist_files, row, 8,&char_tmp);
	gtk_label_set_text(
		lookup_widget( GTK_WIDGET(okno), "label_addres"),
		char_tmp);	
		
	gtk_clist_get_text(clist_files, row, 5,&char_tmp);
	gtk_entry_set_text(
		lookup_widget( GTK_WIDGET(okno), "entry_name"),
		char_tmp);
	
	gtk_clist_get_text(clist_files, row, 6,&char_tmp);
	gtk_entry_set_text(
		lookup_widget( GTK_WIDGET(okno), "entry_comment"),
		char_tmp);
	
	gtk_clist_get_text(clist_files, row, 2,&char_tmp);
	gtk_entry_set_text(
		lookup_widget( GTK_WIDGET(okno), "entry_command"),
		char_tmp);
	
	gtk_clist_get_text(clist_files, row, 1,&char_tmp);
	gtk_combo_box_set_active(
		lookup_widget( GTK_WIDGET(okno), "comboboxentry_folder"),
		whitch_folder_int(char_tmp) );
	
	gtk_button_set_label(
		lookup_widget( GTK_WIDGET(okno), "button2"),
		"");	
	
	
	gtk_clist_get_text(clist_files, row, 3,&char_tmp);	
	icon_icon = g_strdup(char_tmp);
	icon = gtk_image_new();
	gtk_image_set_from_file( icon, imagefinder_path( icon_icon ) );
	gtk_widget_show(icon);
	gtk_button_set_image( lookup_widget(okno, "button2"), 
		icon);	
	
	gtk_clist_get_text(clist_files, row, 7,&char_tmp);
	if(	strcmp(char_tmp, "true") == 0)
		gtk_toggle_button_set_active(
			lookup_widget( GTK_WIDGET(okno), "checkbutton_startuo_notify"),
			TRUE);
	else
		gtk_toggle_button_set_active(
			lookup_widget( GTK_WIDGET(okno), "checkbutton_startuo_notify"),
			FALSE);
	
	
	
	return 0;	
}


int
mainWindow_refrash_clist		(void)
{
	gint i;
	g_print("clist_length %i\n",clist_length);
	
	gtk_widget_destroy(clist_files);
	
	make_firs_search();
	return 0;
}

void
mainWindow_remove_trans					(void)
{
	if( ad_trans_nr != -1 ){
		gtk_clist_remove(
			lookup_widget(okno, "clist3"),
			ad_trans_nr);
		ad_trans_nr = -1;
		filefunc_clist3_minus();
	}
	
}
