#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>

#include "mainWindow.h"
#include "filefunc.h"
#include "imgfind.h"
#include "textDebug.h"



GtkWidget *clist_files;
GtkWidget *okno;
GtkWidget *clist_trans;
GtkWidget *dir_clist;
gint clist_trans_length = 0;

static gchar *dir_path[] = {
	"/usr/share/applications",
	NULL
};

void
filefunc_clist3_minus			(void)
{
	clist_trans_length--;
}

void
filefunc_clist3_plus			(void)
{
	clist_trans_length++;
}

int
find_category						(gchar *a)
{
	gchar *tmp;
	gchar *tmp2;
	gint i = 0;
	gboolean ii,bb;
	gint b = 0;
	tmp = g_strdup(" ");
	gchar *tmp_dirs;
	ii = TRUE;
	bb = TRUE;
	
	//g_print("-> find:%s\n", a);
	
	for( i=0; ii==TRUE; i++)
	{
		tmp_dirs = g_strdup(dirs_static[i]);
		//g_print("find:%s\n",tmp_dirs);		
		
		for( b=0; b<strlen(a) && bb == TRUE; b++)
		{
			tmp2 = g_strdup( a+b );
			tmp2[strlen(tmp_dirs)] = 0;
			
			if( strcmp(tmp2, tmp_dirs) == 0 ){
				tmp = g_strdup(tmp_dirs);
				//g_print("------------found->%s\n",tmp);
				bb = FALSE;				
			}			
		}
		
		
		if( dirs_static[(i+1)] == NULL )
			ii = FALSE;
	}
	
	
		
	return tmp;
}


int
make_rec_from_file				(gchar *a, gboolean t, gint page_no)
{
	FILE *fp;
	gchar *typ;
	gchar *category;
	gchar *exec;
	gchar *icon;
	gchar *name;
	gchar *comment;
	gchar *startup;
	gchar *adress;
	gchar *path;
	gchar *filelines;
	gchar *type_f;
	gchar *genericname;
	gchar *linia;
	linia = malloc(1024);
	gchar *tmp;

	gboolean cnown = FALSE;
	gint rec;
		
	GdkPixbuf *pixbuf_from_file;
	GdkPixbuf *pixbuf_from_pixbuf;
	GdkPixmap *icon_pixmap_from_pixbuf;
	GdkBitmap *icon_mask_form_pixbuf;
	
	rec = 0;
	startup = g_strdup("false");
	category = g_strdup("");
	genericname = g_strdup("");
	
	
	fp = fopen(a , "r");
	if( fp )
	{
		
		filelines = g_strdup("");
		
		while( !feof(fp) )
		{
			cnown = FALSE;
			
			fgets( linia, 1000, fp);
						
			
				linia[strlen(linia)-1] = 0;
					
				// szukanie syfuu
				//printf(g_strdup_printf("plik: %s\nlinia: %s\n", g_strdup(a), g_strdup(linia) ));
				// szukanie syfuu
				
			if( strlen(linia) >=6 )
			{		
				if( strlen(linia) >= 15 )
				{					
					// [Desktop Entry]			
					tmp = g_strdup(linia); 
					tmp[15]= 0; 
					if( strcmp(tmp, "[Desktop Entry]") == 0)
					{
						filelines = g_strdup_printf("%s%s",filelines,"d");
						cnown = TRUE;
					}
				}	// >= 15	
				if( strlen(linia) >= 14 )
				{
					// StartupNotify=			
					tmp = g_strdup(linia); 
					tmp[14]= 0; 
					if( strcmp(tmp, "StartupNotify=") == 0)
					{
						if( strcmp(g_strdup( linia+14 ), "true") == 0 || strcmp(g_strdup( linia+14 ), "True") == 0 || strcmp(g_strdup( linia+14 ), "TRUE") == 0)
							startup = g_strdup("true");
						else 
							startup = g_strdup("false");
						
						rec++;
						filelines = g_strdup_printf("%s%s",filelines,"S");
						cnown = TRUE;
					}		
				}	// >= 14 	
				if( strlen(linia) >= 12 )
				{				
					// GenericName=			
					tmp = g_strdup(linia); 
					tmp[12]= 0; 
					if( strcmp(tmp, "GenericName=") == 0)
					{
						genericname = g_strdup( linia+12 );
						rec++;
						filelines = g_strdup_printf("%s%s",filelines,"G");
						cnown = TRUE;
					} 					
					// GenericName[			
					tmp = g_strdup(linia); 
					tmp[12]= 0; 
					if( strcmp(tmp, "GenericName[") == 0)
					{
						filelines = g_strdup_printf("%s%s",filelines,"g");
						cnown = TRUE;
					} 	
				}	// >= 12
				if( strlen(linia) >= 11 )
				{	
					// Categories=			
					tmp = g_strdup(linia); 
					tmp[11] = 0; 
					if( strcmp(tmp, "Categories=") == 0)
					{
						//g_print("TTT-------------------------------------------------------\n");
						category = find_category(g_strdup( linia+11 ));
						rec++;
						filelines = g_strdup_printf("%s%s",filelines,"K");
						cnown = TRUE;
					} 
				}	// >= 11
				if( strlen(linia) >= 9 )
				{	
					// Encoding=			
					tmp = g_strdup(linia); 
					tmp[9]= 0; 
					if( strcmp(tmp, "Encoding=") == 0)
					{
						filelines = g_strdup_printf("%s%s",filelines,"U");
						cnown = TRUE;
					} 			
				}	// >= 9
				if( strlen(linia) >= 8 )
				{	
					// Comment[			
					tmp = g_strdup(linia); 
					tmp[8]= 0; 
					if( strcmp(tmp, "Comment[") == 0)
					{
						filelines = g_strdup_printf("%s%s",filelines,"c");
						cnown = TRUE;
					} 
					// Comment=			
					tmp = g_strdup(linia); 
					tmp[8]= 0; 
					if( strcmp(tmp, "Comment=") == 0)
					{
						comment = g_strdup( linia+8 );
						rec++;
						filelines = g_strdup_printf("%s%s",filelines,"C");
						cnown = TRUE;
					}
				}	// >= 8
				if( strlen(linia) >= 5 )
				{	
					// Exec=			
					tmp = g_strdup(linia); 
					tmp[5]= 0; 
					if( strcmp(tmp, "Exec=") == 0)
					{
						exec = g_strdup( linia+5 );
						rec++;
						filelines = g_strdup_printf("%s%s",filelines,"E");
						cnown = TRUE;
					} 				
					// Icon=
					if( strcmp(tmp, "Icon=") == 0)
					{
						icon = g_strdup( linia+5 );
						rec++;
						filelines = g_strdup_printf("%s%s",filelines,"I");
						cnown = TRUE;
					} 					
					// Name=
					if( strcmp(tmp, "Name=") == 0)
					{
						name = g_strdup( linia+5 );
						rec++;
						filelines = g_strdup_printf("%s%s",filelines,"N");
						cnown = TRUE;
					} 				
					// Name[
					if( strcmp(tmp, "Name[") == 0)
					{
						filelines = g_strdup_printf("%s%s",filelines,"n");
						cnown = TRUE;
					}				
					// Type=			
					tmp = g_strdup(linia); 
					tmp[5]= 0; 
					if( strcmp(tmp, "Type=") == 0)
					{
						type_f = g_strdup( linia+5 );
						rec++;
						filelines = g_strdup_printf("%s%s",filelines,"T");
						cnown = TRUE;
					} 
				}	// >= 5
				
				
			} // >=6
				
				if( cnown == FALSE)
					filelines = g_strdup_printf("%s%s",filelines,"x");
				
				
			
									
		}
		

		
		if( page_no == 0 ) 
		{
			if( rec >= 6 )
			{
				if( t == TRUE )
					typ = g_strdup("statick");
				else
					typ = g_strdup("dynamick");
				/*	typ, category, exec, icon, ln_icon, name, comment, startup, adress, filelines, genericname, type */	
				gchar *record[] = {typ, category, exec, icon, "", name, comment, startup, a, filelines, genericname, type_f};
				gtk_clist_append(GTK_CLIST(clist_files), record);
				
				
				if( image_true_false(imagefinder_path(icon)) == TRUE ){
					pixbuf_from_file = gdk_pixbuf_new_from_file(imagefinder_path(icon), NULL);
					pixbuf_from_pixbuf = gdk_pixbuf_scale_simple(pixbuf_from_file, 32, 32, TRUE);
					gdk_pixbuf_render_pixmap_and_mask(pixbuf_from_pixbuf, &icon_pixmap_from_pixbuf, &icon_mask_form_pixbuf, 50);
					gtk_clist_set_pixmap(GTK_CLIST(clist_files),clist_length ,4, icon_pixmap_from_pixbuf, icon_mask_form_pixbuf);
				}
				
				clist_length++;
				//g_print("clist_length %i\n",clist_length);		
				
			} else {
				g_print("not complit =====%s=======\n", a);
//				text_debug_add(g_strdup_printf("not complit =====%s=======\n", a));
			}
		} else {
			if( rec >= 2 )
			{
				if( t == TRUE )
					typ = g_strdup("statick");
				else
					typ = g_strdup("dynamick");
				/*	typ, category, exec, icon, ln_icon, name, comment, startup, adress, filelines, genericname, type */	
				gchar *record[] = {typ, category, exec, icon, "", name, comment, startup, a, filelines, genericname, type_f};
				printf("adding a dir structure link\n");
				gint *nr = gtk_clist_append(GTK_CLIST(dir_clist) , record);

				if( image_true_false(imagefinder_path(icon)) == TRUE ){
					pixbuf_from_file = gdk_pixbuf_new_from_file(imagefinder_path(icon), NULL);
					pixbuf_from_pixbuf = gdk_pixbuf_scale_simple(pixbuf_from_file, 32, 32, TRUE);
					gdk_pixbuf_render_pixmap_and_mask(pixbuf_from_pixbuf, &icon_pixmap_from_pixbuf, &icon_mask_form_pixbuf, 50);
					gtk_clist_set_pixmap(GTK_CLIST(dir_clist) ,nr ,4, icon_pixmap_from_pixbuf, icon_mask_form_pixbuf);
				}
	
				//clist_length++;
				//g_print("clist_length %i\n",clist_length);		
				
			} else {
				g_print("not complit =====%s=======\n", a);
//				text_debug_add(g_strdup_printf("not complit =====%s=======\n", a));
			}			
		}
		
		fclose( fp );	
	}	
	
	g_free( linia );
	
	return 0;
}


int
make_file_list						(gchar *a, gboolean t)
{
	
	// PROWIZORA
	gchar *patch;
	patch = g_strdup_printf("ls %s | grep \"\\.desktop\" > /tmp/gnome-menu-editor.tmp", a);
	system(patch);
	
	
	FILE *fp_list;
	gchar *linia;
	linia = malloc(1024);
	clist_length = 0;
	
	
	fp_list = fopen("/tmp/gnome-menu-editor.tmp", "r");
	
	if( fp_list )
	{
		while( !feof(fp_list))
		{
			fgets( linia, 1000, fp_list);
			linia[strlen(linia)-1] = 0;
			make_rec_from_file(g_strdup_printf("%s%s", "/usr/share/applications/",linia), t, 0);
		}
		fclose( fp_list );
	}
	
	remove("/tmp/gnome-menu-editor.tmp");
	
	g_free(linia);
	
	return 0;
}



int
make_firs_search				(void)
{
	gint i=0;
	
	gchar *record[] = {"typ", "category", "exec", "icon", "icon", "name", "comment", "startup", "adress","file lines", "genericname","type"};
	
	clist_files = gtk_clist_new_with_titles(12, record); 
	/*	typ, category, exec, icon, ln_icon, name, comment, startup, adress, filelines, genericname, type */	
	
	while( TRUE )
	{
		if( dir_path[i] == NULL)
		{
			break;		
		} else {
			if( i == 0 )
				make_file_list( dir_path[i] , TRUE);
			else 
				make_file_list( dir_path[i] , FALSE);
		}
		i++;
	}
	
	gtk_container_add(GTK_CONTAINER(lookup_widget(okno, "scrolledwindow1")), clist_files);
	
	gtk_clist_set_sort_column(clist_files, 1);
	gtk_clist_set_sort_type(clist_files, GTK_SORT_ASCENDING);
	gtk_clist_sort(clist_files);
	
	gtk_widget_show( clist_files );
	
	gtk_clist_set_column_auto_resize(clist_files, 0, TRUE);	// typ
gtk_clist_set_column_visibility(clist_files, 0, FALSE);
	gtk_clist_set_column_auto_resize(clist_files, 1, TRUE);	// category
	gtk_clist_set_column_auto_resize(clist_files, 2, TRUE);	// exec
gtk_clist_set_column_visibility(clist_files, 2, FALSE);
	gtk_clist_set_column_auto_resize(clist_files, 3, TRUE);	// icon
gtk_clist_set_column_visibility(clist_files, 3, FALSE);
	//gtk_clist_set_column_auto_resize(clist_files, 4, TRUE);	// not use
//gtk_clist_set_column_visibility(clist_files, 4, FALSE);
gtk_clist_set_column_width(clist_files, 4, 32);
gtk_clist_set_row_height(clist_files, 32);
	gtk_clist_set_column_auto_resize(clist_files, 5, TRUE);	// name
	//gtk_clist_set_column_visibility(clist_files, 5, FALSE);
	gtk_clist_set_column_auto_resize(clist_files, 6, TRUE);	// comment
	//gtk_clist_set_column_visibility(clist_files, 6, FALSE);
	gtk_clist_set_column_auto_resize(clist_files, 7, TRUE);	// startup
gtk_clist_set_column_visibility(clist_files, 7, FALSE);	
	gtk_clist_set_column_auto_resize(clist_files, 8, TRUE);	// adres to file
//gtk_clist_set_column_visibility(clist_files, 8, FALSE);
	gtk_clist_set_column_auto_resize(clist_files, 9, TRUE);	// file lines 
gtk_clist_set_column_visibility(clist_files, 9, FALSE);
	gtk_clist_set_column_auto_resize(clist_files, 10, TRUE);	// generic name
gtk_clist_set_column_visibility(clist_files, 10, FALSE);
	gtk_clist_set_column_auto_resize(clist_files, 11, TRUE);	// type
gtk_clist_set_column_visibility(clist_files, 11, FALSE);
	
	g_signal_connect ((gpointer) clist_files, "select_row",
                    G_CALLBACK (mainWindow_clist_files_wos_selected),
                    NULL);
	
	
	return 0;
}


int
filefunc_put				(gchar *str_to_find, gint coll, gchar *linia)
{
	/* filefunc_put_names("Name[", 1, linia); */
	 
	gchar *str_lang;
	gchar *str_val;
	gchar *str_tmp_lang;
	gboolean found = FALSE;
	gint i;
	gchar *rec_tmp[] = {"", "", "", ""};
	
	clist_trans = lookup_widget(okno, "clist3");
	
		// find lang
	str_lang = g_strdup( linia+strlen(str_to_find) );
	str_lang[ strchr(str_lang, ']')-str_lang ] = 0;	
		
		//find val
	str_val = g_strdup( strchr(linia, '=')+1 ); 
	
	g_print("--lang>%s\n",str_lang);
	
	g_print("---val>%s\n",str_val);
	
	i = 0;
	while ( TRUE )
	{
		if( gtk_clist_get_text(clist_trans, i, 0, &str_tmp_lang) == 0 )
		{
			break;
		} else {
			if( strcmp(str_tmp_lang, str_lang) == 0 )
			{
				g_print("found inserted\n");
				gtk_clist_set_text(clist_trans, i, coll, str_val);
				found = TRUE;
			}
			i++;
		}
	}
	
	if( found == FALSE )
	{
		
		g_print("XX%i\n", clist_trans_length);
		gtk_clist_append(GTK_CLIST(clist_trans), rec_tmp);
		rec_tmp[0] = g_strdup(str_lang);
		rec_tmp[coll] = g_strdup(str_val);
		
		gtk_clist_set_text(clist_trans, clist_trans_length, coll, str_val);
		gtk_clist_set_text(clist_trans, clist_trans_length, 0, str_lang);
		//g_free(rec_tmp);
		clist_trans_length++;
		
	}
	
	return 0;
}


int
filefunc_which_selected		(gint *row)
{
	gchar *addres;
	gchar *cnown;
	FILE *fp;
	gchar *linia;
	gint linieNr;
	gchar *to_print;
	GtkTextBuffer *buffer;
	GtkTextTagTable *to_print_table;
	 GtkTextIter start;
	GtkTextIter end;
	
	/*	typ, category, exec, icon, ln_icon, name, comment, startup, adress, filelines, genericname, type */
	
	gtk_clist_clear(
		lookup_widget(okno, "clist3") );
	
	clist_trans_length = 0;
	buffer = gtk_text_view_get_buffer( 
		lookup_widget( okno, "textview1") );
	linia = malloc(1024);
	gtk_clist_get_text(clist_files, row, 8, &addres);
	gtk_clist_get_text(clist_files, row, 9, &cnown);
	to_print = g_strdup("");
	
	g_print("addres: %s\n", addres);
//	text_debug_add(g_strdup_printf("addres: %s\n", addres));
	g_print("cnown: %s\n", cnown);
//	text_debug_add(g_strdup_printf("cnown: %s\n", cnown));
	
	fp = fopen (addres, "r");
	if( fp )
	{
		linieNr = 0;
		
		gtk_widget_hide(lookup_widget(okno, "clist3"));
		while( !feof(fp))
		{
			gchar cnown_tmp = cnown[linieNr];
			
			g_print("===char:%c line:%i\n",cnown_tmp, linieNr);
//			text_debug_add(g_strdup_printf("===char:%c line:%i\n",cnown_tmp, linieNr));
			
			fgets( linia, 1000, fp);
			linia[strlen(linia)-1] = 0;
			
			if( cnown_tmp == 'x' )
				to_print = g_strdup_printf("%s%s\n", to_print, linia);
			
			if( cnown_tmp == 'n' )
			{
				g_print("found: n\n");
//				text_debug_add("found: n\n");
				filefunc_put("Name[", 1, linia);
			}
			
			if( cnown_tmp == 'c' )
			{
				g_print("found: c\n");
//				text_debug_add("found: c\n");
				filefunc_put("Comment[", 3, linia);
			}
					

			if( cnown_tmp == 'g' )
			{
				g_print("found: g\n");
//				text_debug_add("found: g\n");
				filefunc_put("GenericName[", 2, linia);
			}
							
			linieNr++;
		}
		
		fclose( fp );
		gtk_widget_show(lookup_widget(okno, "clist3"));
	}
	
	g_print("=========\n%s\n===========",to_print);
//	text_debug_add(g_strdup_printf("=========\n%s\n===========\n",to_print));
	
	/*gtk_text_view_set_buffer( 
		lookup_widget(okno, "textview1"),
		to_print_buff);
	*/
	
	gtk_text_buffer_get_start_iter(buffer,&start);
	gtk_text_buffer_get_end_iter(buffer,&end);
	gtk_text_buffer_delete(buffer, &start, &end);
	
	gtk_text_buffer_get_end_iter(buffer,&end);
	gtk_text_buffer_insert(buffer, &end, to_print, -1);
	
	
	return 0;
}
