#include <gtk/gtk.h>
#include <stdio.h>

#include "mainWindow.h"
#include "mv_cp.h"
#include "dirFunc.h"

GtkWidget *okno;
GtkWidget *dir_clist;
GtkWidget *clist_files;

//	row_selected_clipboard

void
mv_cp_copy			(void)
{
	gtk_label_set_text(
		lookup_widget( okno, "label_action"),
		"cp -r");
	
	mv_cp_get_src();	
}

void
mv_cp_cut			(void)
{
	gtk_label_set_text(
		lookup_widget( okno, "label_action"),
		"mv");
	
	mv_cp_get_src();	
}



void
mv_cp_get_src		(void)
{
	GtkWidget *clist_tmp;
	gchar *cell_tmp;
	gint page_no;
	
	page_no = gtk_notebook_get_current_page(
		lookup_widget( okno, "notebook3")
	);
	
	printf(g_strdup_printf("search src data file in row: %i\n", row_selected_clipboard));
		
	if( page_no == 0 )
	{
		gtk_clist_get_text(clist_files, row_selected_clipboard, 8, &cell_tmp);
		gtk_label_set_text(
			lookup_widget( okno, "label_src_file"), 
			g_strdup(cell_tmp));
		gtk_label_set_text(
			lookup_widget( okno, "label_what"), 
			"link");
		
		gtk_clist_get_text(clist_files, row_selected_clipboard, 5, &file_new_name);
		file_new_name = g_strdup(space_replace(file_new_name));
		
	} else {
		gtk_clist_get_text(dir_clist, row_selected_clipboard, 8, &cell_tmp);
		gtk_label_set_text(
			lookup_widget( okno, "label_src_file"), 
			g_strdup(cell_tmp));
		
		gtk_clist_get_text(dir_clist, row_selected_clipboard, 0, &cell_tmp);
		gtk_label_set_text(
			lookup_widget( okno, "label_what"), 
			g_strdup(cell_tmp));
		
	}
	
	gtk_widget_set_sensitive(
		lookup_widget( okno, "button_paste"),
		TRUE		
	);
	
	
}


void
mv_cp_paste			(void)
{
	gint page_no;
	gchar *type_tmp;
	gchar *action; 
	gchar *src_file;
	gchar *dest_file;
	
	type_tmp = g_strdup( gtk_label_get_text(
		lookup_widget( okno, "label_what"))
	);
	action = g_strdup( gtk_label_get_text(
		lookup_widget( okno, "label_action"))
	);
	src_file = g_strdup( gtk_label_get_text(
		lookup_widget( okno, "label_src_file"))
	);
	dest_file = g_strdup( gtk_label_get_text(
		lookup_widget( okno, "label_dest_file"))
	);
		
	page_no = gtk_notebook_get_current_page(
		lookup_widget( okno, "notebook3")
	);

	
	if( page_no == 0 )
	{
		printf("page :0 \n");
		 if( strcmp(type_tmp, "statick") == 0 )
		{
			system( 
				g_strdup_printf("%s %s /usr/share/applications/",
					action,
					src_file,
					dest_file
				)					
			);
			manDirTab_button_execute(FALSE);
			mainWindow_refrash_clist();
		}
		
		
	} else {
		printf("page :1 \n");
		
		
		if( strcmp(type_tmp, g_strdup("dir")) == 0 )
		{
			system( 
				g_strdup_printf("%s %s %s/",
					action,
					src_file,
					dest_file
				)					
			);
			printf(g_strdup_printf("%s %s %s/",
					action,
					src_file,
					dest_file
				));
			manDirTab_button_execute(FALSE);
		} else if( strcmp(type_tmp, "statick") == 0 )
		{
			system( 
				g_strdup_printf("%s %s %s",
					action,
					src_file,
					dest_file
				)					
			);
			manDirTab_button_execute(FALSE);
		}  else if( strcmp(type_tmp, "link") == 0 )
		{
			
			mv_cp_convert_link_to_statick(src_file);
			
			printf(g_strdup_printf("%s /tmp/gmenu_edit_convert.tmp %s/%s.desktop",
					action,
					dest_file,
					file_new_name
				)	
			);
			
			system( 
				g_strdup_printf("%s /tmp/gmenu_edit_convert.tmp %s/%s.desktop",
					action,
					dest_file,
					file_new_name
				)					
			);
			
			if( strcmp(action, "mv") == 0 ) 
			{
				remove("/tmp/gmenu_edit_convert.tmp");
				remove(g_strdup_printf("%s",src_file));
			} else {
				remove("/tmp/gmenu_edit_convert.tmp");
			}
			
			
			manDirTab_button_execute(FALSE);
			mainWindow_refrash_clist();
		}
		
	}
	
	
	gtk_widget_set_sensitive(
		lookup_widget( okno, "button_cut"),
		FALSE		
	);
    gtk_widget_set_sensitive(
		lookup_widget( okno, "button_copy"),
		FALSE		
	);
	gtk_widget_set_sensitive(
		lookup_widget( okno, "button_paste"),
		FALSE		
	);
	
}



int
mv_cp_convert_link_to_statick (gchar *path)
{
	FILE *fp_src;
	FILE *fp_dest;
	gchar *linia;
	gchar *tmp_linia;
	
	
	linia = malloc(1024);
	
	fp_src = fopen(path , "r");
	fp_dest = fopen("/tmp/gmenu_edit_convert.tmp", "w");
	
	if( fp_src && fp_dest )
	{
		while( !feof(fp_src) ){
			fgets( linia, 1000, fp_src);
			linia[(strlen(linia)-1)]=0;
			if( strlen(linia) >=11 )
			{
				tmp_linia = g_strdup(linia);
				tmp_linia[11] = 0;
				if( strcmp(tmp_linia, "Categories=") != 0 )
					fprintf(fp_dest, "%s\n", linia);
				//Categories=
			} else {
				fprintf(fp_dest, "%s\n", linia);
			}		
		}
		fclose( fp_src);
		fclose( fp_dest);
	}

	
	return 0;
		
}
